<?php
    require_once('../../includes/header.inc');
	require_once('../../includes/base_class.inc');
    session::usr_conectado($_REQUEST['USER_ID']);
    require_once('../../includes/write_excel/Worksheet.php');
    require_once('../../includes/write_excel/Workbook.php');

    function HeaderingExcel($filename) {
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=$filename" );
        header("Expires: 0");
        header("Cache-Control: must-revalidate, post-check=0,pre-check=0");
        header("Pragma: public");
    }

    

    $hora = nr2hora(hora_atual());
    $hoje = data_atual('data');

    // HTTP headers
    HeaderingExcel('CLIENTES_COMPRAS.xls');

    // Creating a workbook
    $workbook = new Workbook("-");
    // Creating the first worksheet
    $titulo_sheet = 'CLIENTES VENDAS';
    $worksheet1 =& $workbook->add_worksheet($titulo_sheet);

    // Format for the headings
    $formatot =& $workbook->add_format();
    $formatot->set_size(18);

    $formatost =& $workbook->add_format();
    $formatost->set_size(12);

    $fmt_titulo_c =& $workbook->add_format();
    $fmt_titulo_c->set_align('center');
    $fmt_titulo_c->set_pattern();
    $fmt_titulo_c->set_fg_color(40);
    $fmt_titulo_c->set_bold(1);
    $fmt_titulo_c->set_border(1);

    $fmt_txt_l =& $workbook->add_format();
    $fmt_txt_l->set_align('left');
    $fmt_txt_l->set_border(1);
    $fmt_txt_l->set_size(10);

    $fmt_txt_r =& $workbook->add_format();
    $fmt_txt_r->set_align('right');
    $fmt_txt_r->set_border(1);
    $fmt_txt_r->set_size(10);

    $fmt_txt_c =& $workbook->add_format();
    $fmt_txt_c->set_align('center');
    $fmt_txt_c->set_border(1);
    $fmt_txt_c->set_size(10);

    $fmt_qtd =& $workbook->add_format();
    $fmt_qtd->set_border(1);
    $fmt_qtd->set_align('right');
    $fmt_qtd->set_num_format('@');
    //    $fmt_qtd->set_num_format('#,##0.0##_);-#,##0.0##_)');

	$formato_data =& $workbook->add_format();
	$formato_data->set_border(1);
	$formato_data->set_align('center');
	$formato_data->set_num_format('dd/mm/yyyy');


    // Format for the headings
    $formatotpreco =& $workbook->add_format();
    $formatotpreco->set_border(1);
    $formatotpreco->set_align('left');
//    $formatotpreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00)');
    $formatotpreco->set_num_format('_(R$ * #,##0.00_);_(R$ * (#,##0.00);_(R$ * "-"_);_(@_)');

    // Format for the headings
    $formatotbpreco =& $workbook->add_format();
    $formatotbpreco->set_border(1);
    $formatotbpreco->set_bold(1);
//    $formatotbpreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00);');
    $formatotbpreco->set_align('left');
    $formatotbpreco->set_num_format('_(R$ * #,##0.00_);_(R$ * (#,##0.00);_(R$ * "-"_);_(@_)');


    $filtro = '';

    $worksheet1->write_string(0,0,'RELATRIO DE CLIENTES COM VENDAS',$formatot);
    $worksheet1->set_row(1,6);
    $worksheet1->write(2,0,"Data: ".$hoje." - Hora: ".$hora." - Usurio: ".base64_decode($_REQUEST['USER_ID']));
   // $worksheet1->write(3,0,"Usurio: ".base64_decode($_REQUEST['USER_ID']));
    $worksheet1->set_row(4,6);


    $vendedor = $_REQUEST['vendedor'];
    $cliente = $_REQUEST['cliente'];
    $comprou = $_REQUEST['comprou'];

    //var_dump( $_REQUEST );

    $lista_geral = array();

    $consulta = 'SELECT pc.Pessoa, pc.Vendedor, '. 
                ' pc.Forma_Pagto_Padrao, pc.Meio_Pagto_Padrao, pc.DH_Ultima_Venda, '.
                ' pes.Nome_Razao,  pes.Nome_Fantasia, '.
                ' pes.DataHora_Cadastro,  pes.EMail'.
                ' FROM pessoa_cliente pc '.
                ' INNER JOIN pessoa pes ON '.
                ' pc.Dominio = pes.Dominio AND '.
                ' pc.Pessoa = pes.Pessoa '.
                ' WHERE pc.Dominio = "'.$_SESSION['Dominio'].'"'.
                ' AND (pc.Situacao="A" AND pes.Situacao="A") ';
    if($comprou){
        if( $comprou == 'N'){
            $consulta .=' AND pc.DH_Ultima_Venda = "0000-00-00 00:00:00"';
            $filtro.= ' SEM Vendas ';
        }else{
            $consulta .=' AND pc.DH_Ultima_Venda <>"0000-00-00 00:00:00"';
            $filtro.= ' Com vendas ';
        }
    }
    

    $sub_cabecalho = '';
    if($cliente!=''){
		$consulta.= ' AND pc.Pessoa = "'.$cliente.'" ';
		$cons_cliente = 'select Nome_Razao, Pessoa from pessoa '.
					' where Dominio = "'.$_SESSION["Dominio"].'"'.
					' and Pessoa = "'.$cliente.'"';
		$res_cliente = consulta_sql($cons_cliente);
		$reg_cliente = consulta_ler_linha($res_cliente);
		consulta_limpa($res_cliente);
        $filtro.= ' Cliente: "'.$reg_cliente[0].'"';
    }else{
		$filtro.= ' "Todos os clientes"';
    }
    $consulta.= ' ORDER BY pc.pessoa, pes.Nome_Razao, pc.Pessoa ';

    //echo   $consulta;


    $resultado = consulta_sql($consulta);
    $nrows = consulta_num_registros($resultado);

    $counter = 0;

    for($e=0;$e<$nrows;$e++){
        $registro = consulta_ler_objeto($resultado);

        $counter++;
        if(!isset($lista_geral[$registro->Pessoa])){
            $lista_geral[$registro->Pessoa] = array();
            //$label_emp = empresa_representante($registro->Vendedor,'S');
        }


		$con_ender = 'select Logradouro, Numero, Nome_Cidade, UF, Bairro, CEP '. 
                ' from pessoa_endereco '.
				' where Dominio = "'.$_SESSION['Dominio'].'" '.
				' and Pessoa="'.$registro->Pessoa.'"'.
				' and Situacao ="A"'.
				' order by Seq_Endereco limit 1';
		$res_ender = consulta_sql($con_ender);
		$reg_ender = consulta_ler_linha($res_ender);
		consulta_limpa($res_ender);
		$endereco_log = $reg_ender[0].', ';
		if($reg_ender[1]!=''){
			$endereco_log.=$reg_ender[1];
		}else{
			$endereco_log.='S/N';
		}
		$endereco_cidade = $reg_ender[2];
		$endereco_uf = $reg_ender[3];
		$bairro = $reg_ender[4];
        $endereco_cep  = $reg_ender[5];


		$con_telef = 'select Numero_Telefone from pessoa_telefone '.
				' where Dominio = "'.$_SESSION['Dominio'].'" '.
				' and Pessoa="'.$registro->Pessoa.'"'.
				' and Situacao = "A" '.
				' order by Seq_Telefone limit 2';
		$res_telef = consulta_sql($con_telef);
		$reg_telef = consulta_ler_linha($res_telef);
		$reg_telef2 = consulta_ler_linha($res_telef);
		consulta_limpa($res_telef);
		$telefones = $reg_telef[0];
		if ($reg_telef2[0]!=''){
			$telefones.=', '.$reg_telef2[0];
		}

        $forma_pagto ='';
        if( $registro->Forma_Pagto_Padrao>0){
            $con_forma = 'SELECT Descricao FROM forma_pagto '.
                    ' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
                    ' AND Codigo_Pagto ="'.$registro->Forma_Pagto_Padrao.'"';
            $res_forma = consulta_sql($con_forma);
            $reg_forma = consulta_ler_linha($res_forma);        
            consulta_limpa($res_forma);
            $forma_pagto = $reg_forma[0];
        }
        $meio_pagto = '';
        if( $registro->Meio_Pagto_Padrao!= '' ){
            $meio_pagto = busca_dados_combo('tipo_fatura',  $registro->Meio_Pagto_Padrao);
        }

        $doc = '';
        $valor = '';
        $pago = '';
        if( $registro->DH_Ultima_Venda != '0000-00-00 00:00:00'){
            $con_conta = 'SELECT Nr_Doc, Modelo, Serie, Tipo_Docto, Valor, Meio_Pagto  '.
                    ' FROM contas_pr  '.
                    ' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
                    ' AND Pessoa="'.$registro->Pessoa.'"'.
                    ' AND DH_Criacao = "'.$registro->DH_Ultima_Venda.'" '.
                    ' AND TipoPR = "R" ';
            $res_conta = consulta_sql($con_conta);
            $reg_conta = consulta_ler_linha($res_conta);
            consulta_limpa($res_conta);
            $doc = $reg_conta[0].'/'. $reg_conta[2].'-'.$reg_conta[1];
            $valor = $reg_conta[4];
            $pago .=  busca_dados_combo('tipo_fatura',  $reg_conta[3]); 
            if( $reg_conta[5] > 0){
                $con_forma2 = 'SELECT Descricao FROM forma_pagto '.
                            ' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
                            ' AND Codigo_Pagto ="'.$reg_conta[5].'"';
                $res_forma2 = consulta_sql($con_forma2);
                $reg_forma2 = consulta_ler_linha($res_forma2);        
                consulta_limpa($res_forma2);
                $pago .= ' - '. $reg_forma2[0] ;

            }else{
                $pago .= ' - A VISTA';
            }
        }

        $vendedor = '';
        if( $registro->Vendedor > 0){
            $con_vend = 'SELECT Nome_Listas FROM pessoa '.
                    ' WHERE Dominio = "'.$_SESSION['Dominio'].'" '.
                    ' AND Pessoa ="'.$registro->Vendedor.'"';
            $res_vend = consulta_sql($con_vend);
            $reg_vend = consulta_ler_linha($res_vend);        
            consulta_limpa($res_vend);
            $vendedor = $registro->Vendedor.' - '.$reg_vend[0];
        }
       

        $lista_todos['Vendedor'] = $vendedor;
		$lista_todos['Pessoa'] = $registro->Pessoa;
        $lista_todos['CodigoCliente'] = $registro->Pessoa;
		$lista_todos['NomeCliente'] = $registro->Nome_Razao;
        $lista_todos['CEP'] = $endereco_cep;			
		$lista_todos['Endereco'] = $endereco_log;
		$lista_todos['Cidade'] = $endereco_cidade;
		$lista_todos['Bairro'] = $bairro;
		$lista_todos['UF'] = $endereco_uf;
		$lista_todos['Telefone'] = $telefones;
        $lista_todos['Email'] = $registro->EMail;
		$lista_todos['DataHora_Cadastro'] = $registro->DataHora_Cadastro;
        $lista_todos['DataHora_Venda'] = $registro->DH_Ultima_Venda;       
        $lista_todos['Forma_Pagto'] = $forma_pagto ;
        $lista_todos['Meio_Pagto'] = $meio_pagto ;
        $lista_todos['Doc'] = $doc  ;
        $lista_todos['Valor'] = $valor  ;
        $lista_todos['Info_Pagto'] = $pago ;
        $lista_geral[$registro->Cliente][$registro->Pessoa] = $lista_todos;

    }
    consulta_limpa($resultado);
    


    $worksheet1->write(5,0,"Filtro: ".$filtro);

    $linha_ini = 6;

    if($counter>0){
		$coluna = 0;
		$linha_ini++;

		$worksheet1->set_column($coluna,$coluna,10);
		$worksheet1->write_string($linha_ini,$coluna,'Cliente',$fmt_titulo_c);
		$coluna++;

		$worksheet1->set_column($coluna,$coluna,50);
		$worksheet1->write_string($linha_ini,$coluna,'Nome do Cliente',$fmt_titulo_c);
		$coluna++;

        $worksheet1->set_column($coluna,$coluna,12);
		$worksheet1->write_string($linha_ini,$coluna,'CEP',$fmt_titulo_c);
		$coluna++;

		$worksheet1->set_column($coluna,$coluna,35);
		$worksheet1->write_string($linha_ini,$coluna,'Endereo',$fmt_titulo_c);
		$coluna++;

        $worksheet1->set_column($coluna,$coluna,30);
		$worksheet1->write_string($linha_ini,$coluna,'Bairro',$fmt_titulo_c);
		$coluna++;

		$worksheet1->set_column($coluna,$coluna,25);
		$worksheet1->write_string($linha_ini,$coluna,'Cidade',$fmt_titulo_c);
		$coluna++;
        
        $worksheet1->set_column($coluna,$coluna,8);
		$worksheet1->write_string($linha_ini,$coluna,'UF',$fmt_titulo_c);
		$coluna++;
        
        $worksheet1->set_column($coluna,$coluna,30);
		$worksheet1->write_string($linha_ini,$coluna,'Telefone',$fmt_titulo_c);
		$coluna++;

        $worksheet1->set_column($coluna,$coluna,40);
		$worksheet1->write_string($linha_ini,$coluna,'E-mail',$fmt_titulo_c);
		$coluna++;

        $worksheet1->set_column($coluna,$coluna,40);
		$worksheet1->write_string($linha_ini,$coluna,'Vendedor',$fmt_titulo_c);
		$coluna++;

        $worksheet1->set_column($coluna,$coluna,18);
		$worksheet1->write_string($linha_ini,$coluna,'Pagto Padro',$fmt_titulo_c);
		$coluna++;

        $worksheet1->set_column($coluna,$coluna,25);
		$worksheet1->write_string($linha_ini,$coluna,'Tipo Padro',$fmt_titulo_c);
		$coluna++;

        $worksheet1->set_column($coluna,$coluna,12);
		$worksheet1->write_string($linha_ini,$coluna,'Dt. Cadastro',$fmt_titulo_c);
		$coluna++;

		$worksheet1->set_column($coluna,$coluna,18);
		$worksheet1->write_string($linha_ini,$coluna,'Dt. ltima Compra',$fmt_titulo_c);
		$coluna++;

        $worksheet1->set_column($coluna,$coluna,18);
		$worksheet1->write_string($linha_ini,$coluna,'Documento',$fmt_titulo_c);
		$coluna++;

        $worksheet1->set_column($coluna,$coluna,18);
		$worksheet1->write_string($linha_ini,$coluna,'Valor',$fmt_titulo_c);
		$coluna++;

        $worksheet1->set_column($coluna,$coluna,18);
		$worksheet1->write_string($linha_ini,$coluna,'Forma Pagto',$fmt_titulo_c);
		$coluna++;

       
		$linha_ini++;
		foreach($lista_geral as $cod_vend => $valor_v){
			$lista_geral2 = $lista_geral[$cod_vend];

			$total_cliente = 0;

			foreach($lista_geral2 as $cod_cli => $valor_c){
				$lista_geral3 = $lista_geral2[$cod_cli];


				$coluna = 0;

				$worksheet1->write_string($linha_ini,$coluna,$lista_geral3['CodigoCliente'],$fmt_txt_r);
				$coluna++;

				$worksheet1->write_string($linha_ini,$coluna,$lista_geral3['NomeCliente'],$fmt_txt_l);
				$coluna++;

                $worksheet1->write_string($linha_ini,$coluna,$lista_geral3['CEP'],$fmt_txt_r);
				$coluna++;

				$worksheet1->write_string($linha_ini,$coluna,$lista_geral3['Endereco'],$fmt_txt_l);
				$coluna++;

                $worksheet1->write_string($linha_ini,$coluna,$lista_geral3['Bairro'],$fmt_txt_l);
				$coluna++;

				$worksheet1->write_string($linha_ini,$coluna,$lista_geral3['Cidade'],$fmt_txt_l);
				$coluna++;

				$worksheet1->write_string($linha_ini,$coluna,$lista_geral3['UF'],$fmt_txt_c);
				$coluna++;

				$worksheet1->write_string($linha_ini,$coluna,$lista_geral3['Telefone'],$fmt_txt_l);
				$coluna++;

                $worksheet1->write_string($linha_ini,$coluna,$lista_geral3['Email'],$fmt_txt_l);
				$coluna++;

                $worksheet1->write_string($linha_ini,$coluna,$lista_geral3['Vendedor'],$fmt_txt_l);
				$coluna++;
                
                $worksheet1->write_string($linha_ini,$coluna,$lista_geral3['Forma_Pagto'],$fmt_txt_l);
				$coluna++;

                $worksheet1->write_string($linha_ini,$coluna,$lista_geral3['Meio_Pagto'],$fmt_txt_l);
				$coluna++;

                $worksheet1->write_number($linha_ini,$coluna,data2nr(dataf($lista_geral3['DataHora_Cadastro'])),$formato_data);
				$coluna++;
                
                if( $lista_geral3['DataHora_Venda'] == '0000-00-00 00:00:00' ){
                    $worksheet1->write_string($linha_ini,$coluna,'',$fmt_txt_r);
                }else{
                    $worksheet1->write_number($linha_ini,$coluna,data2nr(dataf($lista_geral3['DataHora_Venda'])),$formato_data);
                }
                $coluna++;

                if( $lista_geral3['Doc'] == ''){
                    $worksheet1->write_string($linha_ini,$coluna,'',$fmt_txt_r);
                }else{
                    $worksheet1->write_string($linha_ini,$coluna,$lista_geral3['Doc'],$fmt_txt_r);
                }
                $coluna++;

                if( $lista_geral3['Valor'] == ''){
                    $worksheet1->write_string($linha_ini,$coluna,'',$fmt_txt_r);
                }else{
                    $worksheet1->write_number($linha_ini,$coluna,$lista_geral3['Valor'],$formatotpreco);
                }
                $coluna++;

                if( $lista_geral3['Info_Pagto'] == ''){
                    $worksheet1->write_string($linha_ini,$coluna,'',$fmt_txt_r);
                }else{
                    $worksheet1->write_string($linha_ini,$coluna,$lista_geral3['Info_Pagto'],$fmt_txt_r);
                }
                $coluna++;
                
                /*
                $ultima_compra = '';
				$ultima_compra_nf = 0;
				$ultima_compra_cf = 0;

                $con_compra_nf = 'SELECT DH_EntSai as DH_Emissao FROM nota_fiscal '.
								' WHERE Dominio = "'.$_SESSION['Dominio'].'"'.
								' AND Empresa = "'.$_SESSION['Empresa_Codigo'].'"'.
								' AND TipoES = "1"'.
								' AND ((Modelo = "01") OR (Modelo = "55")  OR (Modelo = "59") OR (Modelo = "65") OR (Modelo = "98")  )'.
								' AND Situacao = "F" '.
								' AND Nat_Op_Gera_Contas = "R" '.
								' AND Destinatario = "'.$lista_geral3['Pessoa'].'" '.
								' ORDER BY DH_Emissao DESC '.
								' LIMIT 1';
				$res_compra_nf = consulta_sql($con_compra_nf);
				$nrw_compra_nf = consulta_num_registros($res_compra_nf);
				if($nrw_compra_nf > 0){
					$reg_compra_nf = consulta_ler_linha($res_compra_nf);
					$ultima_compra_nf = data2nr(dataf($reg_compra_nf[0]));
				}
				consulta_limpa($res_compra_nf);
                */

				/*----------------------------------------------------------------
                $con_compra_cf = 'SELECT DT_Emissao FROM ecf_cupom '.
								' WHERE Dominio = "'.$_SESSION['Dominio'].'"'.
								' AND Empresa = "'.$_SESSION['Empresa_Codigo'].'"'.
								' AND Cancelado = "N" '.
								' AND Pessoa = "'.$lista_geral3['Pessoa'].'" '.
								' ORDER BY DT_Emissao DESC '.
								' LIMIT 1';
				$res_compra_cf = consulta_sql($con_compra_cf);
				$nrw_compra_cf = consulta_num_registros($res_compra_cf);
				if($nrw_compra_cf > 0){
						$reg_compra_cf = consulta_ler_linha($res_compra_cf);
						$ultima_compra_cf = data2nr(dataf($reg_compra_cf[0]));
				}
				consulta_limpa($res_compra_cf);*/

				/*
                if(($nrw_compra_nf == 0) && ($nrw_compra_cf == 0)){
						$worksheet1->write_string($linha_ini,$coluna,'',$fmt_txt_l);
						$coluna++;
				}else{
					if($ultima_compra_nf >= $ultima_compra_cf){
							$ultima_compra = $ultima_compra_nf;
					}else if($ultima_compra_cf >= $ultima_compra_nf){
							$ultima_compra = $ultima_compra_cf;
			        }
                    $worksheet1->write_number($linha_ini,$coluna,$ultima_compra,$formato_data);
					$coluna++;
				}*/
				
				$linha_ini++;
			}
		}
    }else{
		$worksheet1->write(10,0,"No existem registros para este filtro!");
	}

	//ESTA VARIAVEL  PARA CONTROLAR O TEMPO QUE APARECE O DIV NO MOMENTO DE GERAR O EXCEL
	$insert = 'insert into relatorio_tmp ( '.
			 ' Dominio, '.
			 ' Usuario, '.
			 ' Descricao ) values ('.
			 '"'.$_SESSION['Dominio'].'", '.
			 '"'.base64_decode_si($_REQUEST['USER_ID']).'", '.
			 '"")';
	consulta_sql($insert);
	$workbook->close();
?>