<?php
	require_once('../../includes/header.inc');
	require_once('../../includes/base_class.inc');
	session::usr_conectado($_REQUEST['USER_ID']);
	require_once('../../includes/write_excel/Worksheet.php');
	require_once('../../includes/write_excel/Workbook.php');

	function HeaderingExcel($filename) {
		header("Content-type: application/vnd.ms-excel");
		header("Content-Disposition: attachment; filename=$filename" );
		header("Expires: 0");
		header("Cache-Control: must-revalidate, post-check=0,pre-check=0");
		header("Pragma: public");
	}

	require_once('relatorio_estoque_retro_funcao.php');

	$hora = nr2hora(hora_atual());
	$hoje = data_atual('data');

	// HTTP headers
	HeaderingExcel('POSICAO_ESTOQUE_RETRO.xls');

	// Creating a workbook
	// Creating a workbook
	$workbook = new Workbook("-");
	// Creating the first worksheet
	$titulo_sheet = 'ESTOQUE RETROATIVO';
	$worksheet1 =& $workbook->add_worksheet($titulo_sheet);

	// Format for the headings
	$formatot =& $workbook->add_format();
	$formatot->set_size(18);

	$worksheet1->write_string(0,0,'RELATRIO DE POSIO DE ESTOQUE RETROATIVO',$formatot);
	$worksheet1->write(2,0,config_pad('sistema_licenca'));
	$worksheet1->write(3,0,"Data: ".$hoje." - Hora: ".$hora);
	$worksheet1->write(5,0,"Usurio: ".base64_decode($_REQUEST['USER_ID']));

	$worksheet1->write(8,0,"Filtro: ".$filtro);

	// Format for the headings
	$formatott =& $workbook->add_format();
	$formatott->set_align('center');
	$formatott->set_pattern();
	$formatott->set_fg_color(40);
	$formatott->set_bold(1);
	$formatott->set_border(1);

	// Format for the headings
	$formatotl =& $workbook->add_format();
	$formatotl->set_border(1);

	// Format for the headings
	$formatotc =& $workbook->add_format();
	$formatotc->set_border(1);
	$formatotc->set_align('center');

	// Format for the headings
	$formatotnum =& $workbook->add_format();
	$formatotnum->set_border(1);
	$formatotnum->set_align('right');
	//    $formatotnum->set_num_format('#,##0_);(#,##0)');
	$formatotnum->set_num_format('#,##0.000_);(#,##0.000)');

	// Format for the headings
	$formatotqtd =& $workbook->add_format();
	$formatotqtd->set_border(1);
	$formatotqtd->set_align('right');
	$formatotqtd->set_num_format('[Blue]#,##0_);[Red]-#,##0_)');

	// Format for the headings
	$formatotpreco =& $workbook->add_format();
	$formatotpreco->set_border(1);
	$formatotpreco->set_align('right');
	$formatotpreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00)');

	//negritos
	$formatotbpreco =& $workbook->add_format();
	$formatotbpreco->set_border(1);
	$formatotbpreco->set_align('right');
	$formatotbpreco->set_bold(1);
	$formatotbpreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00)');

	$formatotbqtd =& $workbook->add_format();
	$formatotbqtd->set_border(1);
	$formatotbqtd->set_align('right');
	$formatotbqtd->set_bold(1);
	$formatotbqtd->set_num_format('[Blue]#,##0_);[Red]-#,##0_)');

	$formatotbnum =& $workbook->add_format();
	$formatotbnum->set_border(1);
	$formatotbnum->set_align('right');
	$formatotbnum->set_bold(1);
	//    $formatotbnum->set_num_format('#,##0_);(#,##0)');
	$formatotbnum->set_num_format('#,##0.000_);(#,##0.000)');

	$formatotbl =& $workbook->add_format();
	$formatotbl->set_border(1);
	$formatotbl->set_bold(1);

	$formatotbc =& $workbook->add_format();
	$formatotbc->set_border(1);
	$formatotbc->set_align('center');
	$formatotbc->set_bold(1);

	//formato para peneira
	$formatotlP =& $workbook->add_format();
	$formatotlP->set_border(1);
	$formatotlP->set_italic(1);

	// Format for the headings
	$formatotnumP =& $workbook->add_format();
	$formatotnumP->set_border(1);
	$formatotnumP->set_align('right');
	$formatotnumP->set_num_format('#,##0.000_);(#,##0.000)');
	$formatotnumP->set_italic(1);

	$formato_data =& $workbook->add_format();
	$formato_data->set_border(1);
	$formato_data->set_align('center');
	$formato_data->set_num_format('dd/mm/yyyy');

	$linha_ini = 11;

	if($registros>0){
		$total_saldo = 0;
		$total_valor = 0;
		$soma_total = 0;

		$total_remessas = 0;

		$worksheet1->set_column(0,0,15); //Saldo Atual
		$worksheet1->write_string($linha_ini,0,'Cdigo',$formatott);

		$worksheet1->set_column(1,1,70); //Produto
		$worksheet1->write_string($linha_ini,1,'Produto',$formatott);

		$worksheet1->set_column(2,2,15); //Saldo Atual
		$worksheet1->write_string($linha_ini,2,'Saldo Atual',$formatott);

		$worksheet1->set_column(3,3,15); //Custo/Venda
		$worksheet1->write_string($linha_ini,3, 'Custo', $formatott);

		$worksheet1->set_column(4,4,30); //Vl. Total
		$worksheet1->write_string($linha_ini,4,'Vl. Total',$formatott);
		/*
		$worksheet1->set_column(5,5,15); //Data Mov
		$worksheet1->write_string($linha_ini,5,'Data Mov.',$formatott);

		$worksheet1->set_column(6,6,15); //Fornecedor
		$worksheet1->write_string($linha_ini,6,'Fornecedor',$formatott);

		$worksheet1->set_column(7,7,15); //Preo de Venda
		$worksheet1->write_string($linha_ini,7,'Preo de Venda',$formatott);

		$worksheet1->set_column(8,8,25); //Departamento
		$worksheet1->write_string($linha_ini,8,'Departamento',$formatott);

		$worksheet1->set_column(9,9,15); //Grupo
		$worksheet1->write_string($linha_ini,9,'Grupo',$formatott);

		$worksheet1->set_column(10,10,15); //Linha
		$worksheet1->write_string($linha_ini,10,'Linha',$formatott);

		$worksheet1->set_column(11,11,20); //Marca
		$worksheet1->write_string($linha_ini,11,'Marca',$formatott);

		$worksheet1->set_column(12,12,25); //Produto Fornecedor
		$worksheet1->write_string($linha_ini,12,'Estoque Mnimo',$formatott);

		$worksheet1->set_column(13,13,25); //Localizao
		$worksheet1->write_string($linha_ini,13,'Localizao',$formatott);
		*/
		$linha_ini++;

		foreach($lista_produtos as $chave => $registro){
			set_time_limit(30);
			$ok_linha = true;

			$con_desc = 'SELECT Descricao_Completa,Id_Produto,Terceiros,Codigo_Depart,Codigo_Fornecedor,Estoque_Minimo, '.
					 ' Estoque_Lote,Codigo_Grupo, Codigo_Linha,Marca FROM produto '.
					 ' WHERE Dominio = "'.$_SESSION['Dominio'].'"'.
					 ' AND Id_Produto="'.$registro['Id_Produto'].'"';
			$res_desc = consulta_sql($con_desc);
			$reg_desc = consulta_ler_linha($res_desc);
			consulta_limpa($res_desc);
			/*
			$cons_depart = 'SELECT Descricao, Controle_Lote FROM produto_departamento '.
						' WHERE Dominio = "'.$_SESSION['Dominio'].'"'.
						' AND Codigo_Depart = "'.$reg_desc[3].'"'.
						' AND Situacao = "A"';
			$res_depart = consulta_sql($cons_depart);
			$reg_depart = consulta_ler_linha($res_depart);
			consulta_limpa($res_depart);

			$cons_grupo = 'SELECT Descricao, Codigo_Grupo FROM produto_grupo '.
					   ' WHERE Dominio = "'.$_SESSION['Dominio'].'"'.
					   ' AND Codigo_Depart = "'.$reg_desc[3].'"'.
					   ' AND Codigo_Grupo = "'.$reg_desc[7].'"'.
					   ' AND Situacao = "A"';
			$res_grupo = consulta_sql($cons_grupo);
			$reg_grupo = consulta_ler_linha($res_grupo);
			consulta_limpa($res_grupo);

			$cons_linha = 'SELECT Descricao, Codigo_Linha FROM produto_linha '.
					   ' WHERE Dominio = "'.$_SESSION['Dominio'].'"'.
					   ' AND Codigo_Depart = "'.$reg_desc[3].'"'.
					   ' AND Codigo_Grupo = "'.$reg_desc[7].'"'.
					   ' AND Codigo_Linha = "'.$reg_desc[8].'"'.
					   ' AND Situacao = "A"';
			$res_linha = consulta_sql($cons_linha);
			$reg_linha = consulta_ler_linha($res_linha);
			consulta_limpa($res_linha);

			$cons_marca = 'SELECT Descricao, Codigo_Marca FROM produto_marca  '.
					   ' WHERE Dominio = "'.$_SESSION['Dominio'].'"'.
					   ' AND Codigo_Marca = "'.$reg_desc[9].'"'.
					   ' AND Situacao="A"';
			$res_marca = consulta_sql($cons_marca);
			$reg_marca = consulta_ler_linha($res_marca);
			consulta_limpa($res_marca);
			*/

			if($ok_linha){
				$worksheet1->write_string($linha_ini,0,$reg_desc[1],$formatotqtd); //Codigo

				$desc_produto = $reg_desc[0];
				$worksheet1->write_string($linha_ini,1,$desc_produto,$formatotl); //Produto

				$total = $registro['Custo'] * $registro['Saldo'];

				$worksheet1->write_number($linha_ini,2,$registro['Saldo'],$formatotnum); //Saldo Atual
				$worksheet1->write_number($linha_ini,3,$registro['Custo'],$formatotpreco);
				$worksheet1->write_number($linha_ini,4,$total,$formatotpreco);
				//$worksheet1->write_number($linha_ini,5,data2nr(dataf($registro['Data_Mov'])),$formato_data); //Dt. Movto
				/* $con_fornec = 'SELECT Nome_Listas, Pessoa FROM pessoa '.
						  ' WHERE Dominio = "'.$_SESSION['Dominio'].'"'.
						  ' AND Pessoa = "'.$registro['Codigo_Fornecedor'].'"';
				$res_fornec = consulta_sql($con_fornec);
				$reg_fornec = consulta_ler_linha($res_fornec);
				consulta_limpa($res_fornec);*/

				//$worksheet1->write_string($linha_ini,6,$registro['Codigo_Fornecedor'].' - '.$reg_fornec[0],$formatotl); //Fornecedor
				//$worksheet1->write_number($linha_ini,7,$registro['Preco_Venda1'],$formatotnum);
				//$worksheet1->write_string($linha_ini,8,$reg_depart[0],$formatotl);
				//$worksheet1->write_string($linha_ini,9,$reg_grupo[0],$formatotl);
				//$worksheet1->write_string($linha_ini,10,$reg_linha[0],$formatotl);
				//$worksheet1->write_string($linha_ini,11,$reg_marca[0],$formatotl);
				//$worksheet1->write_string($linha_ini,12, $registro['Estoque_Minimo'],$formatotnum);
				//$worksheet1->write_string($linha_ini,13, $reg_localizacao[0],$formatotl);
				/*$con_localizacao = 'SELECT Localizacao FROM produto_saldo_filial '.
							   ' WHERE Dominio = "'.$_SESSION["Dominio"].'"'.
							   ' AND Codigo_Empresa = "'.$_SESSION['Empresa_Codigo'].'"'.
							   ' AND Id_Produto = "'.$registro['Id_Produto'].'"'.
							   ' AND Local_Armaz = 0';
				$res_localizacao = consulta_sql($con_localizacao);
				// TODO: consulta retornando false, verificar
				if($res_localizacao!=false){
				$reg_localizacao = consulta_ler_linha($res_localizacao);
				consulta_limpa($res_localizacao);
				}
				//$worksheet1->write_string($linha_ini,15, $reg_localizacao[0],$formatotl); //Localizao
				*/
				if($campos_remessas){
					if(isset($remessas[$registro['Id_Produto']])){
						$qtd_remessas = $remessas[$registro['Id_Produto']];
					}else{
						$qtd_remessas = 0;
					}
					$worksheet1->write_number($linha_ini,16,$qtd_remessas,$formatotnum); //Ponto de Pedido
					$worksheet1->write_number($linha_ini,17,$registro['Saldo'] - $qtd_remessas,$formatotnum); //Ponto de Pedido
					$total_remessas+= $qtd_remessas;
				}

				$linha_ini++;
				$total_valor+= $total;
				$total_saldo+= $registro['Saldo'];
			}
		}

		//TOTAIS
		$worksheet1->set_column(4,4,18);
		$worksheet1->write_string($linha_ini,0,'TOTAL',$formatotbc);
		$worksheet1->write_string($linha_ini,1,'',$formatotbc);
		$worksheet1->write_number($linha_ini,2,$total_saldo,$formatotbnum);
		$worksheet1->write_string($linha_ini,3,'',$formatotbc);
		$worksheet1->write_number($linha_ini,4,$total_valor,$formatotbpreco);
		//$worksheet1->write_string($linha_ini,5,'',$formatotbc);
		//$worksheet1->write_string($linha_ini,6,'',$formatotbc);
		//$worksheet1->write_string($linha_ini,7,'',$formatotbc);
		//$worksheet1->write_string($linha_ini,8,'',$formatotbc);
		//$worksheet1->write_string($linha_ini,9,'',$formatotbc);
		//$worksheet1->write_string($linha_ini,10,'',$formatotbc);
		//$worksheet1->write_string($linha_ini,11,'',$formatotbc);
		//$worksheet1->write_string($linha_ini,12,'',$formatotbc);
		//$worksheet1->write_string($linha_ini,13,'',$formatotbc);
		//$worksheet1->write_string($linha_ini,14,'',$formatotbc);
		//$worksheet1->write_string($linha_ini,15,'',$formatotbc);

		if($campos_remessas){
			$worksheet1->write_number($linha_ini,16,$total_remessas,$formatotbnum);
			$worksheet1->write_number($linha_ini,17,$total_saldo-$total_remessas,$formatotbnum);
		}
		$linha_ini++;
	}else{
		$worksheet1->write(10,0,"No existem registros para este filtro!");
	}
	//consulta_limpa($resultado);
	//ESTA VARIAVEL  PARA CONTROLAR O TEMPO QUE APARECE A DIV NO MOMENTO DE GERAR O EXCEL
	$insert = 'insert into relatorio_tmp ( '.
			 ' Dominio, '.
			 ' Usuario, '.
			 ' Descricao ) values ('.
			 '"'.$_SESSION['Dominio'].'", '.
			 '"'.base64_decode_si($_REQUEST['USER_ID']).'", '.
			 '"")';
	consulta_sql($insert);
	$workbook->close();
?>