<?
	require_once('../../includes/header.inc');
	require_once('../../includes/base_class.inc');
	session::usr_conectado($_REQUEST['USER_ID']);
	require_once('../../includes/write_excel/Worksheet.php');
	require_once('../../includes/write_excel/Workbook.php');

	function HeaderingExcel($filename) {
		header("Content-type: application/vnd.ms-excel");
		header("Content-Disposition: attachment; filename=$filename" );
		header("Expires: 0");
		header("Cache-Control: must-revalidate, post-check=0,pre-check=0");
		header("Pragma: public");
	}

	$hora = nr2hora(hora_atual());
	$hoje = data_atual('data');

	// HTTP headers
	HeaderingExcel('MOV_CLIENTE.xls');

	// Creating a workbook
	$workbook = new Workbook("-");
	// Creating the first worksheet
	$titulo_sheet = 'MOV CLIENTE';
	$worksheet1 =& $workbook->add_worksheet($titulo_sheet);

	// Format for the headings
	$formatot =& $workbook->add_format();
	$formatot->set_size(18);

	$formatost =& $workbook->add_format();
	$formatost->set_size(14);

	$worksheet1->write_string(0,0,'RELATRIO DE MOVIMENTAES DE CLIENTES',$formatot);
	$worksheet1->write(2,0,config_pad('sistema_licenca'));
	$worksheet1->write(3,0,"Data: ".$hoje." - Hora: ".$hora);
	$worksheet1->write(5,0,"Usurio: ".base64_decode($_REQUEST['USER_ID']));

	$label = label_vendedor_ou_rep_comercial('S');

	$data_ini = $_REQUEST['dt_ini'];
	$data_fim = $_REQUEST['dt_fim'];
	$tp_rel = $_REQUEST['tp_rel'];
	$valor_base = str2nr(formata_valor($_REQUEST['valor']));

	$filtro = '';
	$filtro.= 'Perodo:';
	$filtro.= ' De "'.$data_ini.'" At "'.$data_fim.'"';

	if ($tp_rel=='S'){
		$filtro.= ' Sem movimentao no perodo';
	}else{
		if ($tp_rel=='B'){
			$txt_tipo = 'Abaixo';
		}else{
			$txt_tipo = 'Acima';
		}
		//if($valor_base!=''){
		$filtro.= ' Com movimentao '.$txt_tipo.' do valor '.to_money($valor_base).' ';
		//}
	}

	$lista_cli = array();

	$consulta = 'SELECT Destinatario,sum(Total_NF) '.
				' from nota_fiscal '.
				' where Dominio = "'.$_SESSION['Dominio'].'" '.
				' and (Situacao="F") '.
				' and (DH_EntSai >= "'.datad($data_ini).'") '.
				' and (DH_EntSai <= "'.datad($data_fim).' 23:59:59")'.
				' and (TipoES="1") and (Nat_Op_Gera_Contas="R")'.
				' group by Destinatario';
	$res_doc = consulta_sql($consulta);
	$nrw_doc = consulta_num_registros($res_doc);
	for ($n=0;$n<$nrw_doc;$n++){
		$reg_doc = consulta_ler_linha($res_doc);
		if (!isset($lista_cli[$reg_doc[0]])){
			$lista_cli[$reg_doc[0]]=0;
		}
		$lista_cli[$reg_doc[0]]+=$reg_doc[1];
	}
	consulta_limpa($res_doc);

	$consulta = 'SELECT Pessoa,sum((SubTotal+Acrescimo)-Desconto) '.
				' from ecf_cupom '.
				' where Dominio = "'.$_SESSION['Dominio'].'" '.
				' and (Cancelado="N") '.
				' and (DT_Emissao >= "'.datad($data_ini).'") '.
				' and (DT_Emissao <= "'.datad($data_fim).'")'.
				' group by Pessoa';
	$res_doc = consulta_sql($consulta);
	$nrw_doc = consulta_num_registros($res_doc);
	for ($n=0;$n<$nrw_doc;$n++){
		$reg_doc = consulta_ler_linha($res_doc);
		if (!isset($lista_cli[$reg_doc[0]])){
			$lista_cli[$reg_doc[0]]=0;
		}
		$lista_cli[$reg_doc[0]]+=$reg_doc[1];
	}
	consulta_limpa($res_doc);

	$cont=0;
	$lista_nova = '0';
	foreach($lista_cli as $pessoa => $valor){
		if ($tp_rel=='B'){
			if ($valor<$valor_base){
				$lista_nova.= ','.$pessoa;
				$cont++;
			}
		}else if ($tp_rel=='C'){
			if ($valor>=$valor_base){
				$lista_nova.= ','.$pessoa;
				$cont++;
			}
		}else{
			$lista_nova.= ','.$pessoa;
			$cont++;
		}
	}

	$con_cli = 'select Pessoa,Nome_Razao, EMail from pessoa '.
			   ' where Dominio = "'.$_SESSION['Dominio'].'" '.
			   ' and Pessoa in ('.$lista_nova.')'.
			   ' and Situacao<>"E"'.
			   ' order by Nome_Razao';
	if ($tp_rel=='S'){
		$con_cli = 'select Pessoa,Nome_Razao, EMail from pessoa '.
				  ' where Dominio = "'.$_SESSION['Dominio'].'" '.
				  ' and not (Pessoa in ('.$lista_nova.'))'.
				  ' and Situacao<>"E"'.
				  ' and (DataHora_Cadastro<="'.datad($data_fim).' 23:59:59")'.
				  ' and (substring(pessoa.Cadastros,1,1)="S")'.
				  ' order by Nome_Razao';
	}
	//echo $con_cli;

	$worksheet1->write(8,0,"Filtro: ".$filtro);
	//$worksheet1->insert_bitmap(9,0,"../../imgs/logo_menu.bmp",0,0);

	// Formato cabecalho
	$formatott =& $workbook->add_format();
	$formatott->set_align('center');
	$formatott->set_pattern();
	$formatott->set_fg_color(40);
	$formatott->set_bold(1);
	$formatott->set_border(1);

	// Formato texto
	$formatotc =& $workbook->add_format();
	$formatotc->set_border(1);
	$formatotc->set_align('center');

	$formatotl =& $workbook->add_format();
	$formatotl->set_border(1);
	$formatotl->set_align('left');

	$formatotlb =& $workbook->add_format();
	$formatotlb->set_border(1);
	$formatotlb->set_size(10);
	//$formatotlb->set_align('left');
	$formatotlb->set_bold(1);

	// Formato quantidade
	$formatotqtd =& $workbook->add_format();
	$formatotqtd->set_border(1);
	$formatotqtd->set_align('right');
	$formatotqtd->set_num_format('#,##0_);-#,##0_)');

	$formatotqtdb =& $workbook->add_format();
	$formatotqtdb->set_border(1);
	$formatotqtdb->set_align('right');
	$formatotqtdb->set_size(10);
	$formatotqtdb->set_bold(1);
	$formatotqtdb->set_num_format('#,##0_);(-#,##0_)');

	// 3 casas
	$formatotqtd3 =& $workbook->add_format();
	$formatotqtd3->set_border(1);
	$formatotqtd3->set_align('right');
	$formatotqtd3->set_num_format('#,##0.000_);(#,##0.000)');

	$formatotbqtd3 =& $workbook->add_format();
	$formatotbqtd3->set_border(1);
	$formatotbqtd3->set_bold(1);
	$formatotbqtd3->set_align('right');
	$formatotbqtd3->set_num_format('#,##0.000_);(#,##0.000)');

	// Formato preco/valor
	$formatotpreco =& $workbook->add_format();
	$formatotpreco->set_border(1);
	$formatotpreco->set_align('right');
	$formatotpreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00)');

	$formatotbpreco =& $workbook->add_format();
	$formatotbpreco->set_border(1);
	$formatotbpreco->set_align('right');
	$formatotbpreco->set_bold(1);
	$formatotbpreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00)');

	$resultado = consulta_sql($con_cli);
	$nrows = consulta_num_registros($resultado);

	$linha_ini = 10;

	if ($nrows>0){
		$coluna=0;
		//if ($tp_rel=='S'){
		//}else{
		//	$worksheet1->set_column($coluna,$coluna,30);
		//}

		$worksheet1->set_column($coluna,$coluna,50);
		$worksheet1->write_string($linha_ini,$coluna,'Razo Social',$formatott);
		$coluna++;

		$worksheet1->set_column($coluna,$coluna,10);
		$worksheet1->write_string($linha_ini,$coluna,'Cdigo',$formatott);
		$coluna++;

		$worksheet1->set_column($coluna,$coluna,15);
		$worksheet1->write_string($linha_ini,$coluna,'Telefone',$formatott);
		$coluna++;

		//if ($tp_rel=='S'){
		//}else{
		//	$worksheet1->set_column($coluna,$coluna,15);
		//}
		$worksheet1->set_column($coluna,$coluna,20);
		$worksheet1->write_string($linha_ini,$coluna,'E-mail',$formatott);
		$coluna++;

		$worksheet1->set_column($coluna,$coluna,50);
		$worksheet1->write_string($linha_ini,$coluna,'Endereo',$formatott);
		$coluna++;

		if ($tp_rel!='S'){
			$worksheet1->set_column($coluna,$coluna,15);
			$worksheet1->write_string($linha_ini,$coluna,'Valor',$formatott);
			$coluna++;
		}

		if($_SESSION['Dominio'] == '4'){
			$worksheet1->set_column($coluna,$coluna,25);
			$worksheet1->write_string($linha_ini,$coluna,'Vendedor',$formatott);
			$coluna++;
		}

		$linha_ini++;
		$id_conta = '';
		$valor_total = 0;

		for ($i=0;$i<$nrows;$i++){
			$registro = consulta_ler_objeto($resultado);
			set_time_limit(30);

			$con_ender = 'select Logradouro, Numero, Nome_Cidade, UF, Complemento from pessoa_endereco '.
						 ' where Dominio = "'.$_SESSION['Dominio'].'" '.
						 ' and Pessoa="'.$registro->Pessoa.'"'.
						 ' and Situacao <> "E"'.
						 ' order by Seq_Endereco limit 1';
			$res_ender = consulta_sql($con_ender);
			$reg_end = consulta_ler_objeto($res_ender);
			consulta_limpa($res_ender);

			$con_ender = 'select Numero_Telefone from pessoa_telefone '.
						 ' where Dominio = "'.$_SESSION['Dominio'].'" '.
						 ' and Pessoa="'.$registro->Pessoa.'"'.
						 ' and Situacao <> "E"'.
						 ' order by Seq_Telefone limit 2';
			$res_ender = consulta_sql($con_ender);
			$reg_fone = consulta_ler_objeto($res_ender);
			consulta_limpa($res_ender);

			$coluna=0;
			$worksheet1->write_string($linha_ini,$coluna,$registro->Nome_Razao,$formatotl);
			$coluna++;

			$worksheet1->write_string($linha_ini,$coluna,$registro->Pessoa,$formatotl);
			$coluna++;

			$worksheet1->write_string($linha_ini,$coluna,$reg_fone->Numero_Telefone,$formatotl);
			$coluna++;

			$worksheet1->write_string($linha_ini,$coluna,$registro->EMail,$formatotl);
			$coluna++;

			$endereco = $reg_end->Logradouro;
			if ($reg_end->Numero!=''){
				$endereco.= ',S/N';
			}else{
				$endereco.= ','.$reg_end->Numero;
			}
			if ($reg_end->Complemento!=''){
				$endereco.= ' '.$reg_end->Complemento;
			}

			$worksheet1->write_string($linha_ini,$coluna,$endereco,$formatotl);
			$coluna++;

			if ($tp_rel!='S'){
				$vlr_compras = 0;
				if (isset($lista_cli[$registro->Pessoa])){
					$vlr_compras = $lista_cli[$registro->Pessoa];
				}
				$worksheet1->write_number($linha_ini,$coluna,$vlr_compras,$formatotpreco);
				$coluna++;
			}

			if($_SESSION['Dominio'] == '4'){
				$con_cliente = 'select Vendedor from pessoa_cliente '.
							  ' where Dominio = "'.$_SESSION['Dominio'].'" '.
							  ' and Pessoa = "'.$registro->Pessoa.'"'.
							  ' and Situacao <> "E"';
				$res_cliente = consulta_sql($con_cliente);
				$reg_cliente = consulta_ler_linha($res_cliente);
				consulta_limpa($res_cliente);

				if($reg_cliente[0] != ''){
					$con_vend = 'select Nome_Razao from pessoa '.
							  ' where Dominio = "'.$_SESSION['Dominio'].'" '.
							  ' and Pessoa = "'.$reg_cliente[0].'"'.
							  ' and Situacao<>"E"';
					$res_vend = consulta_sql($con_vend);
					$reg_vend = consulta_ler_linha($res_vend);
					consulta_limpa($res_vend);

					$worksheet1->write_string($linha_ini,$coluna,$reg_vend[0],$formatotl);
					$coluna++;
				}
			}
			$linha_ini++;
		}
	}else{
		$worksheet1->write(10,0,"No existem registros para este filtro!");
	}
	consulta_limpa($resultado);
	//ESTA VARIAVEL  PARA CONTROLAR O TEMPO QUE APARECE O DIV NO MOMENTO DE GERAR O EXCEL
	$insert = 'insert into relatorio_tmp ( '.
			  ' Dominio, '.
			  ' Usuario, '.
			  ' Descricao ) values ('.
			  '"'.$_SESSION['Dominio'].'", '.
			  '"'.base64_decode_si($_REQUEST['USER_ID']).'", '.
			  '"")';
	consulta_sql($insert);
	$workbook->close();

?>