<?php
    require_once('../../includes/header.inc');
	require_once('../../includes/base_class.inc');
    session::usr_conectado($_REQUEST['USER_ID']);
    require_once('../../includes/write_excel/Worksheet.php');
    require_once('../../includes/write_excel/Workbook.php');
    require_once('relatorio_produto_fornec_funcao.php');

    function HeaderingExcel($filename) {
        header("Content-type: application/vnd.ms-excel");
        header("Content-Disposition: attachment; filename=$filename" );
        header("Expires: 0");
        header("Cache-Control: must-revalidate, post-check=0,pre-check=0");
        header("Pragma: public");
    }

    $hora = nr2hora(hora_atual());
    $hoje = data_atual('data');

    // HTTP headers
    HeaderingExcel('Produtos_Fornecedor.xls');

    // Creating a workbook
    $workbook = new Workbook("-");
    // Creating the first worksheet
    $titulo_sheet = 'Produtos_Fornecedor';
    $worksheet1 =& $workbook->add_worksheet($titulo_sheet);

    // Format for the headings
    $formatot =& $workbook->add_format();
    $formatot->set_size(18);

    $formatost =& $workbook->add_format();
    $formatost->set_size(14);

    $worksheet1->write_string(0,0,'RELATRIO DE PRODUTOS POR FORNECEDOR',$formatot);
    $worksheet1->write(2,0,config_pad('sistema_licenca'));
    $worksheet1->write(3,0,"Data: ".$hoje." - Hora: ".$hora);
    $worksheet1->write(5,0,"Usurio: ".base64_decode($_REQUEST['USER_ID']));

    $worksheet1->write(6,0,"Filtro: ".$filtro);
    //$worksheet1->insert_bitmap(9,0,"../../imgs/logo_menu.bmp",0,0);

    // Formato cabecalho Centralizado
    $formatott =& $workbook->add_format();
    $formatott->set_align('center');
    $formatott->set_pattern();
    $formatott->set_fg_color(40);
    $formatott->set_bold(1);
    $formatott->set_border(1);

    // Formato cabecalho Esquerda
    $formatoTLeft =& $workbook->add_format();
    $formatoTLeft->set_align('left');
    $formatoTLeft->set_pattern();
    $formatoTLeft->set_fg_color(40);
    $formatoTLeft->set_bold(1);
    $formatoTLeft->set_border(1);

    // Formato texto
    $formatotc =& $workbook->add_format();
    $formatotc->set_border(1);
    $formatotc->set_align('center');

    $formatotl =& $workbook->add_format();
    $formatotl->set_border(1);
    $formatotl->set_align('left');

    $formatotr =& $workbook->add_format();
    $formatotr->set_border(1);
    $formatotr->set_align('right');

    $formatotlb =& $workbook->add_format();
    $formatotlb->set_border(1);
    $formatotlb->set_size(10);
    //$formatotlb->set_align('left');
    $formatotlb->set_bold(1);


    // Formato quantidade
    $formatotqtd =& $workbook->add_format();
    $formatotqtd->set_border(1);
    $formatotqtd->set_align('right');
    $formatotqtd->set_num_format('@');

    $formatotqtdb =& $workbook->add_format();
    $formatotqtdb->set_border(1);
    $formatotqtdb->set_align('right');
    $formatotqtdb->set_size(10);
    $formatotqtdb->set_bold(1);
    $formatotqtdb->set_num_format('@');

    // 3 casas
    $formatotqtd3 =& $workbook->add_format();
    $formatotqtd3->set_border(1);
    $formatotqtd3->set_align('right');
    $formatotqtd3->set_num_format('#,##0.000_);(#,##0.000)');

    $formatotbqtd3 =& $workbook->add_format();
    $formatotbqtd3->set_border(1);
    $formatotbqtd3->set_bold(1);
    $formatotbqtd3->set_align('right');
    $formatotbqtd3->set_num_format('#,##0.000_);(#,##0.000)');

    // Formato preco/valor
    $formatotpreco =& $workbook->add_format();
    $formatotpreco->set_border(1);
    $formatotpreco->set_align('right');
    $formatotpreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00)');

    $formatotbpreco =& $workbook->add_format();
    $formatotbpreco->set_border(1);
    $formatotbpreco->set_align('right');
    $formatotbpreco->set_bold(1);
    $formatotbpreco->set_num_format('R$ #,##0.00_);(R$ #,##0.00)'); 

    $linha_ini =8 ;
    set_time_limit(60);
    
	$resultado = consulta_sql($consulta);
	$nrows = consulta_num_registros($resultado);
    if ($nrows>0){
        //Apresentao do titulo
        $coluna=0;		
        $worksheet1->set_column($coluna,$coluna,20);
        $worksheet1->write_string($linha_ini,$coluna,'Cdigo', $formatoTLeft);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,70);
        $worksheet1->write_string($linha_ini,$coluna,'Produto', $formatoTLeft);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,10);
        $worksheet1->write_string($linha_ini,$coluna,'Un. Venda ',$formatott);
        $coluna++;
        
        $worksheet1->set_column($coluna,$coluna,15);
        $worksheet1->write_string($linha_ini,$coluna,'Qtd. Estoque',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,15);
        $worksheet1->write_string($linha_ini,$coluna,'Preo de Venda',$formatott);
        $coluna++;

        $worksheet1->set_column($coluna,$coluna,20);
        $worksheet1->write_string($linha_ini,$coluna,'Departamento',$formatott);
        $coluna++; 

        if( $ana_modas){
            $worksheet1->set_column($coluna,$coluna,25);
            $worksheet1->write_string($linha_ini,$coluna,'Vendido',$formatott);
            $coluna++; 
        }
       
        $linha_ini++;
        $ncampos = $coluna ;
		$valor = 0;
		$id_fornec = '';
		$total_forn = 0;
		$qtd_prod = 0;
		$qtd_venda = 0;
        $total_geral_forn = 0;
        $qtd_ttl_prod = 0;
        $total_vendido = 0; 
        $qtd_ttl_vendida = 0;

        $lista_empresas = lista_empresas();

        //recomecando a apresentao do EXCEL com o Dominio $anna_modas

        //Comea a Apresentar as Informaes 
        //foreach( $lista_rel as $key =>  $value ){
        for ($i=0;$i<$nrows;$i++){
            $registro = consulta_ler_objeto($resultado);
            set_time_limit(60);
            $ok_linha = true;
            //Verifca se algum departamento foi selecionado
            if($ok_linha){
				if($depart!=''){
					$ok_linha = (isset($depart[$registro->Codigo_Depart]));
				}
			}
            if($ok_linha){
				if($id_fornec!=$registro->Codigo_Fornecedor ){
					if(  $id_fornec  !=''){
                        $coluna = 0;
                        $worksheet1->write_string($linha_ini,$coluna,   'Total do Fornecedor' ,$formatotlb);
                        $coluna++;
                        $worksheet1->write_string($linha_ini,$coluna,  'Quantidade de Produtos: '.$qtd_prod ,$formatotlb);
                        $coluna++;
                        $worksheet1->write_string($linha_ini,$coluna,  '' ,$formatotlb);
                        $coluna++;
                        $worksheet1->write_string($linha_ini,$coluna,  '',$formatotlb);
                        $coluna++;
                        $worksheet1->write_number($linha_ini,$coluna,  $total_forn ,    $formatotbpreco  );
                        $coluna++;
                        
                        if( $ana_modas){
                            $worksheet1->write_string($linha_ini,$coluna,  'Total Vendido: ',$formatotlb);
                            $coluna++;
                            $worksheet1->write_number($linha_ini,$coluna, $qtd_venda , $formatotqtdb );
                            $coluna++;
                        }
                        else{
                            $worksheet1->write_string($linha_ini,$coluna,  ' ',$formatotlb);
                            $coluna++;
                        }
                        $linha_ini++;
						$total_forn = 0;
						$qtd_prod = 0;
						$qtd_venda = 0;
                        //$qtd_ttl_vendida = 0;
					}

					$id_fornec = $registro->Codigo_Fornecedor; // $value['Fornecedor'];
                    $cons_forn = 'select Nome_Razao, Pessoa from pessoa '.
								 ' where Dominio = "'.$_SESSION["Dominio"].'"'.
								 ' and Pessoa = "'.$id_fornec.'"';
					$res_forn = consulta_sql($cons_forn);
					$reg_forn = consulta_ler_linha($res_forn);
					consulta_limpa($res_forn);
                   
                    $coluna=0;
					$linha_ini++; 
                    $worksheet1->write_string($linha_ini,$coluna,'Fornecedor: '. $registro->Codigo_Fornecedor .' - '.$reg_forn[0],$formatotlb);

                    ($ana_modas)? $cel_merge= 5: $cel_merge= 4;
					$worksheet1->merge_cells($linha_ini, $coluna, $linha_ini, $coluna+$cel_merge);
					for($ca=0;$ca<=$cel_merge;$ca++){
						$coluna++;
						$worksheet1->write_blank($linha_ini,$coluna,$formatotc); //acertar bordas
					}
                    $linha_ini++;
				}//Fornecedor Diferente

                //Nome dos Departamentos
                $cons_depart = 'SELECT Descricao FROM produto_departamento  '.
							' WHERE Dominio = "'.$_SESSION["Dominio"].'"'.
							' AND Codigo_Depart = "'.$registro->Codigo_Depart.'"';
				$res_depart = consulta_sql($cons_depart);
				$reg_depart = consulta_ler_linha($res_depart);
				consulta_limpa($res_depart);

				//Apresentar os produtos
                $coluna = 0;
                $worksheet1->write_string($linha_ini,$coluna, $registro->Codigo_Produto ,$formatotl);
			    $coluna++;
                
                $worksheet1->write_string($linha_ini,$coluna, $registro->Descricao_Completa ,$formatotl);
                $coluna++;
                
                $worksheet1->write_string($linha_ini,$coluna, $registro->Unidade_Venda ,$formatotc);
                $coluna++;
                
                $worksheet1->write_number($linha_ini,$coluna,   $registro->Estoque_Atual, $formatotqtd);
                $coluna++; 

                $worksheet1->write_number($linha_ini,$coluna,  $registro->Preco_Venda1 , $formatotpreco );
                $coluna++;

                $worksheet1->write_string($linha_ini,$coluna,  $reg_depart[0] , $formatotr);
                $coluna++;
                //Para Dominio 355 deixando igual ao relatorio em pdf realizado em  22/08/2023 por @isabel 
                if ($ana_modas){
					if(isset($lista_rel2[$registro->Id_Produto]['Qtd'])){
						$qtd_venda+=$lista_rel2[$registro->Id_Produto]['Qtd'];
						$valor_prod = $lista_rel2[$registro->Id_Produto]['Qtd'];
                         // $total_vendido +=$lista_rel2[$registro->Id_Produto]['Qtd'];
                         // $qtd_ttl_vendida  +=$lista_rel2[$registro->Id_Produto]['Qtd'];
                       
					}else{
						$valor_prod = '';
                        $qtd_venda+=0;
					}
                    $worksheet1->write_number($linha_ini,$coluna,  $valor_prod , $formatotqtd );
                    $coluna++;

                     // 
                     $total_vendido += $lista_rel2[$registro->Id_Produto]['Qtd'];
                     // 
                     $qtd_ttl_vendida  +=  $lista_rel2[$registro->Id_Produto]['Qtd'];
                }
                $linha_ini++;
                $qtd_prod++;
				$total_forn+= $registro->Preco_Venda1;
                $total_geral_forn+= $registro->Preco_Venda1;
                $qtd_ttl_prod++;


                // $total_vendido +=$qtd_venda;
                // $qtd_ttl_vendida  +=$qtd_venda;
                
              

			}

        }//Fim foreach

        //Finalizou toda a apresentacao e pega as informaes do ltimo fornecedor
        if( $id_fornec!= '' ){
            //recoloca a parte das finalizaes
            //Sem esta parte no ir aparecer a Totalizacao do Ultimo Fornecedor
            $coluna = 0;
            $worksheet1->write_string($linha_ini,$coluna,   'Total do Fornecedor' ,$formatotlb);
            $coluna++;
            $worksheet1->write_string($linha_ini,$coluna,  'Quantidade de Produtos: '.$qtd_prod ,$formatotlb);
            $coluna++;
            $worksheet1->write_string($linha_ini,$coluna,  '' ,$formatotlb);
            $coluna++;
            $worksheet1->write_string($linha_ini,$coluna,  '',$formatotlb);
            $coluna++;
            $worksheet1->write_number($linha_ini,$coluna,  $total_forn ,    $formatotbpreco  );
            $coluna++;
            if( $ana_modas){
                $worksheet1->write_string($linha_ini,$coluna,  'Total Vendido: ',$formatotlb);
                $coluna++;
                $worksheet1->write_number($linha_ini,$coluna,  $total_vendido ,   $formatotqtdb  );
                $coluna++;
            }else{
                $worksheet1->write_string($linha_ini,$coluna,  '',$formatotlb);
                $coluna++;
            }
            $linha_ini++;

            $total_forn = 0;
            $qtd_prod = 0;
            $qtd_venda = 0;
            $total_vendido = 0; 
            //$qtd_ttl_vendida =0;

        }
        //Totalizao do Relatrio
        $linha_ini++;
        $coluna = 0;
        $worksheet1->write_string($linha_ini, $coluna,  'Total Geral' ,$formatotlb);
        $coluna++;
        $worksheet1->write_string($linha_ini,$coluna,  'Quantidade Total de Produtos: '.$qtd_ttl_prod ,$formatotlb);
        $coluna++;
        $worksheet1->write_string($linha_ini,$coluna,  '' ,$formatotlb);
        $coluna++;
        $worksheet1->write_string($linha_ini,$coluna,  'Valor Total'    ,$formatotlb);
        $coluna++;
        $worksheet1->write_number($linha_ini,$coluna,   $total_geral_forn  ,    $formatotbpreco  );
        $coluna++;

        if( $ana_modas){
            $worksheet1->write_string($linha_ini,$coluna,  'Geral Vendido: ',$formatotlb);
            $coluna++;
            $worksheet1->write_number($linha_ini,$coluna, $qtd_ttl_vendida ,  $formatotqtdb  );
            $coluna++;
        }else{
            $worksheet1->write_string($linha_ini,$coluna,  '',$formatotlb);
            $coluna++;
        }
        
        
        $linha_ini++;

    }else{
        $worksheet1->write(10,0,"No existem registros para este filtro!");
    }
    
    //ESTA VARIAVEL  PARA CONTROLAR O TEMPO QUE APARECE O DIV NO MOMENTO DE GERAR O EXCEL
    $insert = 'insert into relatorio_tmp ( '.
              ' Dominio, '.
              ' Usuario, '.
              ' Descricao ) values ('.
              '"'.$_SESSION['Dominio'].'", '.
              '"'.base64_decode_si($_REQUEST['USER_ID']).'", '.
              '"")';
    consulta_sql($insert);
    $workbook->close();
?>